#ifndef _LINUX_ERR_H
#define _LINUX_ERR_H

#include <linux/compiler.h>

#include <asm/errno.h>

/*
 * Kernel pointers have redundant information, so we can use a
 * scheme where we can return either an error code or a dentry
 * pointer with the same return value.
 *
 * This should be a per-architecture thing, to allow different
 * error and pointer decisions.
 */
#define IS_ERR_VALUE(x) unlikely((x) > (unsigned long)-1000L)

static inline void * SNT ERR_PTR(long error)
{
	return (void * SNT) TC(error);
}

/*
static inline long PTR_ERR(const void *ptr)
{
	return (long) ptr;
}
*/
#define PTR_ERR(ptr) ((long)TC(ptr))

/*
static inline long IS_ERR(const void *ptr)
{
	return IS_ERR_VALUE((unsigned long)TC(ptr));
}
*/
#define IS_ERR(ptr) IS_ERR_VALUE((unsigned long)TC(ptr))

#endif /* _LINUX_ERR_H */
