#ifndef INCLUDE_LINUX_KRECOVER_API_H
#define INCLUDE_LINUX_KRECOVER_API_H 1

#ifdef KRECOVER
/* Real krecover API */
#include <linux/krecover.h>
#else
/*
 * Dummies for compiling without recovery support 
 */

/* Values of these doesn't really matter */
typedef enum kr_comp_type {
  KR_ANY = 0, 			/* this is for kr_remove_object() only */
  KR_SPINLOCK, KR_SPINLOCK_IRQSAVE, KR_SPINLOCK_IRQ, KR_SPINLOCK_BH,
  KR_KMALLOC, KR_IOREMAP,
  KR_KOBJECT, KR_PCI_ALLOC_CONSISTENT, KR_PCI_REGIONS, KR_PCI_ENABLE_DEVICE, KR_PCI_DRIVER,
  KR_SKB, KR_ALLOC_NETDEV, KR_REGISTER_NETDEV,
  KR_TIMER, KR_IRQ, KR_NETIF_START_QUEUE,
  KR_SCSI_ADD_HOST, KR_USB_BUFFER_ALLOC, KR_USB_REGISTER,
  KR_SND_CARD_REGISTER, KR_SND_DMA_ALLOC_PAGES,
  KR_END			/* has to be the last one! */
} kr_comp_type_t;

struct kr_object;
#define kr_recover(x) do {(void(x); } while(0)
#define kr_add_object(x,y,z) do { (void)x; (void)y; (void)z; } while(0)
#define kr_add_object_dup(x,y,z) do { (void)x; (void)y; (void)z; } while(0)
#define kr_add_object_raw(x) do { (void)x; } while(0)
#define kr_remove_object(x,y) do { (void)x; (void)y; } while(0)
#define kr_remove_object_any(x) do { (void)x; } while(0)
#define kr_remove_object_not_found(x,y) do { (void)x; } while(0)
#define kr_enter_driver(x) do { } while(0)
#define kr_enter_driver_rec(x) do { } while(0)
#define kr_enter_driver_noret() do { } while(0)
#define kr_enter_driver_rec_noret() do { } while(0)
#define kr_exit_driver() do {} while(0)
#define kr_trigger_fault() do {} while(0)
#endif

#endif
